var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import { WelcomePresenter } from '../../shared/Welcome/WelcomePresenter';
import { ButtonType } from '../../types';
import { filterTeachingQueries, useWelcomeWidgetConfig, } from '../../hooks/useWelcomeWidget';
export var WelcomeTeaching = function () {
    var _a = useWelcomeWidgetConfig(filterTeachingQueries), openApp = _a.openApp, loading = _a.loading, error = _a.error, atqId = _a.atqId, greeting = _a.greeting, formattedNewSessionsCount = _a.formattedNewSessionsCount, formattedStartedSessionsCount = _a.formattedStartedSessionsCount, formattedReviewSessionCount = _a.formattedReviewSessionCount;
    var getUrl = function (filterType) {
        return window.document.location.origin + "?appId=" + atqId + "&taskFilters[filters][0]=" + filterType;
    };
    var welcomeProps = {
        loading: loading,
        error: error,
        greeting: greeting,
        subTitle: 'Nice to have you here! Let’s get some work done together!',
        sessionsButtonsConfig: [
            {
                text: 'Show Tasks',
                onClick: function () { return openApp(atqId, { action: 'show-new-sessions' }); },
                id: 'New Tasks',
                buttonText: 'New Tasks',
                btnType: ButtonType.primary,
                buttonTextCount: formattedNewSessionsCount,
                href: getUrl('AIE_NEW_CONVERSION_TASKS'),
            },
            {
                text: 'Show Tasks',
                onClick: function () { return openApp(atqId, { action: 'show-started-sessions' }); },
                id: 'Started Tasks',
                buttonText: 'Started Tasks',
                btnType: ButtonType.secondary,
                buttonTextCount: formattedStartedSessionsCount,
                href: getUrl('AIE_OWN_CONVERSION_TASKS'),
            },
            {
                text: 'Show Tasks',
                onClick: function () {
                    return openApp(atqId, { action: 'show-new-tasks-to-be-reviewed' });
                },
                id: 'Tasks to be reviewed',
                buttonText: 'Tasks to be reviewed',
                btnType: ButtonType.tertiary,
                buttonTextCount: formattedReviewSessionCount,
                href: getUrl('AIE_OWN_NEW_REVIEW_TASKS'),
            },
        ],
    };
    return React.createElement(WelcomePresenter, __assign({}, welcomeProps));
};
