var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import styled from 'styled-components';
import { ProgressBar } from "../../components/elements";
import { isOwner, isParticipantInReview, isReviewer, isReviewRequested, allReviewersAreParticipants, getReviewerIds, getParticipantIds, } from '../utils';
var NewStatus = styled.span.withConfig({ displayName: "NewStatus", componentId: "sc-2cp94o" })(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  color: ", ";\n  font-weight: 700;\n"], ["\n  color: ", ";\n  font-weight: 700;\n"])), function (_a) {
    var theme = _a.theme;
    return theme.colors.primary.default;
});
var IndicatorOptions;
(function (IndicatorOptions) {
    IndicatorOptions["EYE"] = "eye";
    IndicatorOptions["HANDSHAKE"] = "handshake";
    IndicatorOptions["CODE"] = "code";
    IndicatorOptions["COMMENTS"] = "comments";
})(IndicatorOptions || (IndicatorOptions = {}));
var IndicatorStatusOptions;
(function (IndicatorStatusOptions) {
    IndicatorStatusOptions["CHECK"] = "check";
    IndicatorStatusOptions["EXCLAMATION"] = "exclamation";
})(IndicatorStatusOptions || (IndicatorStatusOptions = {}));
function withoutOwner(_a, sme) {
    var conversionOwnerId = _a.conversionOwnerId, teachingOwnerId = _a.teachingOwnerId;
    return sme ? !teachingOwnerId : !conversionOwnerId;
}
function hasStarted(_a, sme) {
    var _b = _a.teachingRooms, teachingRooms = _b === void 0 ? 0 : _b, _c = _a.teachingStepsDeployed, teachingStepsDeployed = _c === void 0 ? 0 : _c;
    return sme ? teachingRooms > 0 : teachingStepsDeployed > 0;
}
function isStepsDeployed(_a) {
    var teachingSteps = _a.teachingSteps, teachingStepsDeployed = _a.teachingStepsDeployed;
    return Boolean(teachingStepsDeployed &&
        teachingSteps &&
        teachingStepsDeployed > 0 &&
        teachingSteps > 0 &&
        teachingStepsDeployed === teachingSteps);
}
function isRoomsCompleted(_a) {
    var teachingRooms = _a.teachingRooms, teachingRoomsCompleted = _a.teachingRoomsCompleted;
    return Boolean(teachingRoomsCompleted &&
        teachingRooms &&
        teachingRoomsCompleted > 0 &&
        teachingRooms > 0 &&
        teachingRoomsCompleted === teachingRooms);
}
export function getIndicatorData(session, sme, currentUserId, reviewerIds, participantIds) {
    var handedOver = session.handedOver, conversionOwnerId = session.conversionOwnerId, teachingOwnerId = session.teachingOwnerId;
    var indicatorData = {
        indicatorStatusIconColor: 'primary',
        indicatorStatusIcon: IndicatorStatusOptions.CHECK,
    };
    if (sme && handedOver) {
        return __assign(__assign({}, indicatorData), { indicator: IndicatorOptions.HANDSHAKE });
    }
    var roomsCompleted = isRoomsCompleted(session);
    var stepsDeployed = isStepsDeployed(session);
    if (!sme && stepsDeployed) {
        return __assign(__assign({}, indicatorData), { indicator: IndicatorOptions.CODE });
    }
    if (sme && roomsCompleted) {
        return __assign(__assign({}, indicatorData), { indicator: IndicatorOptions.COMMENTS });
    }
    var owner = isOwner(sme, currentUserId, {
        teachingOwnerId: teachingOwnerId,
        conversionOwnerId: conversionOwnerId,
    });
    var reviewRequested = isReviewRequested(reviewerIds);
    var reviewer = isReviewer(currentUserId, reviewerIds);
    if ((owner && reviewRequested) || reviewer) {
        var allReviewersCompleted = allReviewersAreParticipants(reviewerIds, participantIds);
        var participant = isParticipantInReview(currentUserId, participantIds);
        if (Boolean(owner && allReviewersCompleted) ||
            Boolean(reviewer && participant)) {
            return __assign(__assign({}, indicatorData), { indicator: IndicatorOptions.EYE });
        }
        return {
            indicator: IndicatorOptions.EYE,
            indicatorStatusIcon: IndicatorStatusOptions.EXCLAMATION,
            indicatorStatusIconColor: 'orange',
        };
    }
    return {};
}
function getPopoverText(session, sme, currentUserId, reviewerIds, participantIds) {
    var teachingOwnerId = session.teachingOwnerId, handedOver = session.handedOver, conversionOwnerId = session.conversionOwnerId;
    if (sme && handedOver) {
        return 'Handover done';
    }
    var roomsCompleted = isRoomsCompleted(session);
    var stepsDeployed = isStepsDeployed(session);
    if (!sme && stepsDeployed) {
        return 'Conversion completed';
    }
    if (sme && roomsCompleted) {
        return 'Chat completed';
    }
    var owner = isOwner(sme, currentUserId, {
        teachingOwnerId: teachingOwnerId,
        conversionOwnerId: conversionOwnerId,
    });
    var reviewRequested = isReviewRequested(reviewerIds);
    var reviewer = isReviewer(currentUserId, reviewerIds);
    var allReviewersCompleted = allReviewersAreParticipants(reviewerIds, participantIds);
    if (owner) {
        if (reviewRequested) {
            if (allReviewersCompleted) {
                return 'Review completed';
            }
            return 'Review requested';
        }
        else {
            return 'No review required';
        }
    }
    if (reviewer) {
        var participant = isParticipantInReview(currentUserId, participantIds);
        if (participant) {
            return 'Review delivered';
        }
        return 'Review required';
    }
}
function getTotal(_a, sme) {
    var _b = _a.teachingRooms, teachingRooms = _b === void 0 ? 0 : _b, _c = _a.teachingSteps, teachingSteps = _c === void 0 ? 0 : _c;
    return sme ? teachingRooms : teachingSteps;
}
function getCurrent(_a, sme) {
    var _b = _a.teachingRoomsCompleted, teachingRoomsCompleted = _b === void 0 ? 0 : _b, _c = _a.teachingStepsDeployed, teachingStepsDeployed = _c === void 0 ? 0 : _c;
    return sme ? teachingRoomsCompleted : teachingStepsDeployed;
}
export var SessionProgressBar = function (_a) {
    var session = _a.session, _b = _a.sme, sme = _b === void 0 ? false : _b, currentUserId = _a.currentUserId;
    var reviewerIds = getReviewerIds(sme, session);
    var participantIds = getParticipantIds(sme, session);
    var total = getTotal(session, sme);
    var current = getCurrent(session, sme);
    var popover = getPopoverText(session, sme, currentUserId, reviewerIds, participantIds);
    var _c = getIndicatorData(session, sme, currentUserId, reviewerIds, participantIds), indicator = _c.indicator, indicatorStatusIcon = _c.indicatorStatusIcon, indicatorStatusIconColor = _c.indicatorStatusIconColor;
    var label = sme ? 'Steps completed' : 'Steps converted';
    var noOwner = withoutOwner(session, sme);
    var notStarted = !hasStarted(session, sme);
    if (noOwner && notStarted) {
        return React.createElement(NewStatus, null, "NEW");
    }
    return (React.createElement(ProgressBar, { label: label, indicator: indicator, staticIcon: indicator === IndicatorOptions.CODE, total: total, current: current, popover: popover, indicatorStatusIcon: indicatorStatusIcon, indicatorStatusIconColor: indicatorStatusIconColor }));
};
var templateObject_1;
